Index: testsuites/ada/samples/base_sp/config.h
===================================================================
--- testsuites/ada/samples/base_sp/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/samples/base_sp/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/samples/ticker/config.h
===================================================================
--- testsuites/ada/samples/ticker/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/samples/ticker/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp01/config.h
===================================================================
--- testsuites/ada/sptests/sp01/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp01/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp02/config.h
===================================================================
--- testsuites/ada/sptests/sp02/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp02/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp03/config.h
===================================================================
--- testsuites/ada/sptests/sp03/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp03/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp04/config.h
===================================================================
--- testsuites/ada/sptests/sp04/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp04/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp05/config.h
===================================================================
--- testsuites/ada/sptests/sp05/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp05/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp06/config.h
===================================================================
--- testsuites/ada/sptests/sp06/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp06/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp07/config.h
===================================================================
--- testsuites/ada/sptests/sp07/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp07/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp08/config.h
===================================================================
--- testsuites/ada/sptests/sp08/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp08/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp09/config.h
===================================================================
--- testsuites/ada/sptests/sp09/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp09/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp11/config.h
===================================================================
--- testsuites/ada/sptests/sp11/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp11/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp12/config.h
===================================================================
--- testsuites/ada/sptests/sp12/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp12/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp13/config.h
===================================================================
--- testsuites/ada/sptests/sp13/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp13/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp14/config.h
===================================================================
--- testsuites/ada/sptests/sp14/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp14/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp15/config.h
===================================================================
--- testsuites/ada/sptests/sp15/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp15/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp16/config.h
===================================================================
--- testsuites/ada/sptests/sp16/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp16/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp17/config.h
===================================================================
--- testsuites/ada/sptests/sp17/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp17/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -13,6 +13,4 @@
 
 /* configuration information */
-
-#define CONFIGURE_SPTEST
 
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
Index: testsuites/ada/sptests/sp19/config.h
===================================================================
--- testsuites/ada/sptests/sp19/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp19/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp20/config.h
===================================================================
--- testsuites/ada/sptests/sp20/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp20/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp22/config.h
===================================================================
--- testsuites/ada/sptests/sp22/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp22/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp23/config.h
===================================================================
--- testsuites/ada/sptests/sp23/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp23/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp24/config.h
===================================================================
--- testsuites/ada/sptests/sp24/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp24/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
Index: testsuites/ada/sptests/sp25/config.h
===================================================================
--- testsuites/ada/sptests/sp25/config.h	(revision 0b4063022239406c828606c982604bdd9cbc28bc)
+++ testsuites/ada/sptests/sp25/config.h	(revision 6899a8d79d235e4782ccd525136673fb322e5a17)
@@ -14,6 +14,4 @@
 /* configuration information */
 
-#define CONFIGURE_SPTEST
-
 #define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER