Index: c/src/lib/libbsp/shared/ChangeLog
===================================================================
--- c/src/lib/libbsp/shared/ChangeLog	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/ChangeLog	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -1,2 +1,8 @@
+2003-09-04	Joel Sherrill <joel@OARcorp.com>
+
+	* bootcard.c, bspclean.c, clockdrv_shell.c, console-polled.c,
+	console.c, ide_ctrl.c, main.c, sbrk.c, setvec.c, tod.c, tod.h,
+	include/coverhd.h: URL for license changed.
+
 2003-08-16	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: c/src/lib/libbsp/shared/bootcard.c
===================================================================
--- c/src/lib/libbsp/shared/bootcard.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/bootcard.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -12,5 +12,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/bspclean.c
===================================================================
--- c/src/lib/libbsp/shared/bspclean.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/bspclean.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -7,5 +7,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/clockdrv_shell.c
===================================================================
--- c/src/lib/libbsp/shared/clockdrv_shell.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/clockdrv_shell.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -7,5 +7,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/console-polled.c
===================================================================
--- c/src/lib/libbsp/shared/console-polled.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/console-polled.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -9,5 +9,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/console.c
===================================================================
--- c/src/lib/libbsp/shared/console.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/console.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -10,5 +10,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/ide_ctrl.c
===================================================================
--- c/src/lib/libbsp/shared/ide_ctrl.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/ide_ctrl.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -10,5 +10,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  * 
  * $Id$
Index: c/src/lib/libbsp/shared/include/coverhd.h
===================================================================
--- c/src/lib/libbsp/shared/include/coverhd.h	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/include/coverhd.h	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -9,5 +9,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/main.c
===================================================================
--- c/src/lib/libbsp/shared/main.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/main.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -12,5 +12,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/sbrk.c
===================================================================
--- c/src/lib/libbsp/shared/sbrk.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/sbrk.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -12,5 +12,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/setvec.c
===================================================================
--- c/src/lib/libbsp/shared/setvec.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/setvec.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -19,5 +19,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  */
Index: c/src/lib/libbsp/shared/tod.c
===================================================================
--- c/src/lib/libbsp/shared/tod.c	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/tod.c	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -4,5 +4,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/shared/tod.h
===================================================================
--- c/src/lib/libbsp/shared/tod.h	(revision c483a4e2214c0df9b99cc95a33c7a16335d7fe98)
+++ c/src/lib/libbsp/shared/tod.h	(revision 7050ec709b1897bf70204d8c76e4b6f619687563)
@@ -9,5 +9,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$