Index: c/src/exec/libfs/ChangeLog
===================================================================
--- c/src/exec/libfs/ChangeLog	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ c/src/exec/libfs/ChangeLog	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -1,2 +1,11 @@
+2002-06-17	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* src/dosfs/Makefile.am: Include $(top_srcdir)/../automake/*.am.
+	* src/Makefile.am: Include $(top_srcdir)/../automake/*.am.
+	* src/imfs/Makefile.am: Include $(top_srcdir)/../automake/*.am.
+	* Makefile.am: Include $(top_srcdir)/../automake/*.am.
+	Use ../aclocal.
+	* wrapup/Makefile.am: Include $(top_srcdir)/../automake/*.am.
+
 2002-05-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: c/src/exec/libfs/Makefile.am
===================================================================
--- c/src/exec/libfs/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ c/src/exec/libfs/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -3,5 +3,5 @@
 ##
 
-ACLOCAL_AMFLAGS = -I ../../../../aclocal
+ACLOCAL_AMFLAGS = -I ../aclocal
 
 SUBDIRS = src wrapup
@@ -9,4 +9,4 @@
 EXTRA_DIST = README
 
-include $(top_srcdir)/../../../../automake/subdirs.am
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/subdirs.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/exec/libfs/src/Makefile.am
===================================================================
--- c/src/exec/libfs/src/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ c/src/exec/libfs/src/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -6,4 +6,4 @@
 SUBDIRS = imfs dosfs
 
-include $(top_srcdir)/../../../../automake/subdirs.am
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/subdirs.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/exec/libfs/src/dosfs/Makefile.am
===================================================================
--- c/src/exec/libfs/src/dosfs/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ c/src/exec/libfs/src/dosfs/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -4,7 +4,7 @@
 
 
-include $(top_srcdir)/../../../../automake/multilib.am
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
+include $(top_srcdir)/../automake/multilib.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/lib.am
 
 INCLUDES = -I../..
@@ -53,3 +53,3 @@
 EXTRA_DIST = $(DOSFS_C_FILES) $(FATFS_C_FILES)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/exec/libfs/src/imfs/Makefile.am
===================================================================
--- c/src/exec/libfs/src/imfs/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ c/src/exec/libfs/src/imfs/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -33,7 +33,7 @@
 include_HEADERS = imfs.h
 
-include $(top_srcdir)/../../../../automake/multilib.am
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
+include $(top_srcdir)/../automake/multilib.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/lib.am
 
 PREINSTALL_FILES = $(PROJECT_INCLUDE) \
@@ -64,3 +64,3 @@
     $(UNIX_C_FILES)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/exec/libfs/wrapup/Makefile.am
===================================================================
--- c/src/exec/libfs/wrapup/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ c/src/exec/libfs/wrapup/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -7,7 +7,7 @@
 LIB = $(ARCH)/$(LIBNAME).a
 
-include $(top_srcdir)/../../../../automake/multilib.am
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
+include $(top_srcdir)/../automake/multilib.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/lib.am
 
 IMFSLIB = ../src/imfs/$(ARCH)/libimfs.a
@@ -40,3 +40,3 @@
 .PRECIOUS: $(LIB)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: cpukit/libfs/ChangeLog
===================================================================
--- cpukit/libfs/ChangeLog	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ cpukit/libfs/ChangeLog	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -1,2 +1,11 @@
+2002-06-17	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* src/dosfs/Makefile.am: Include $(top_srcdir)/../automake/*.am.
+	* src/Makefile.am: Include $(top_srcdir)/../automake/*.am.
+	* src/imfs/Makefile.am: Include $(top_srcdir)/../automake/*.am.
+	* Makefile.am: Include $(top_srcdir)/../automake/*.am.
+	Use ../aclocal.
+	* wrapup/Makefile.am: Include $(top_srcdir)/../automake/*.am.
+
 2002-05-18	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/libfs/Makefile.am
===================================================================
--- cpukit/libfs/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ cpukit/libfs/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -3,5 +3,5 @@
 ##
 
-ACLOCAL_AMFLAGS = -I ../../../../aclocal
+ACLOCAL_AMFLAGS = -I ../aclocal
 
 SUBDIRS = src wrapup
@@ -9,4 +9,4 @@
 EXTRA_DIST = README
 
-include $(top_srcdir)/../../../../automake/subdirs.am
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/subdirs.am
+include $(top_srcdir)/../automake/local.am
Index: cpukit/libfs/src/Makefile.am
===================================================================
--- cpukit/libfs/src/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ cpukit/libfs/src/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -6,4 +6,4 @@
 SUBDIRS = imfs dosfs
 
-include $(top_srcdir)/../../../../automake/subdirs.am
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/subdirs.am
+include $(top_srcdir)/../automake/local.am
Index: cpukit/libfs/src/dosfs/Makefile.am
===================================================================
--- cpukit/libfs/src/dosfs/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ cpukit/libfs/src/dosfs/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -4,7 +4,7 @@
 
 
-include $(top_srcdir)/../../../../automake/multilib.am
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
+include $(top_srcdir)/../automake/multilib.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/lib.am
 
 INCLUDES = -I../..
@@ -53,3 +53,3 @@
 EXTRA_DIST = $(DOSFS_C_FILES) $(FATFS_C_FILES)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: cpukit/libfs/src/imfs/Makefile.am
===================================================================
--- cpukit/libfs/src/imfs/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ cpukit/libfs/src/imfs/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -33,7 +33,7 @@
 include_HEADERS = imfs.h
 
-include $(top_srcdir)/../../../../automake/multilib.am
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
+include $(top_srcdir)/../automake/multilib.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/lib.am
 
 PREINSTALL_FILES = $(PROJECT_INCLUDE) \
@@ -64,3 +64,3 @@
     $(UNIX_C_FILES)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: cpukit/libfs/wrapup/Makefile.am
===================================================================
--- cpukit/libfs/wrapup/Makefile.am	(revision 6e183f18cd60f6bacb48afc8c88c49b51a844112)
+++ cpukit/libfs/wrapup/Makefile.am	(revision 7077c8778b483c2eb720d3b7929bcaf62ca61a97)
@@ -7,7 +7,7 @@
 LIB = $(ARCH)/$(LIBNAME).a
 
-include $(top_srcdir)/../../../../automake/multilib.am
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
+include $(top_srcdir)/../automake/multilib.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/lib.am
 
 IMFSLIB = ../src/imfs/$(ARCH)/libimfs.a
@@ -40,3 +40,3 @@
 .PRECIOUS: $(LIB)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am