Index: c/src/lib/libbsp/sparc/erc32/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/erc32/Makefile.am	(revision 38c0b1121f12e992fff6a85c18d8cabdbee0e213)
+++ c/src/lib/libbsp/sparc/erc32/Makefile.am	(revision 7121cac0ccd234ac4d95abb2642ac0075c7fc1d0)
@@ -30,4 +30,5 @@
 # startup
 libbsp_a_SOURCES += ../../shared/bspclean.c ../../shared/bsplibc.c \
+    ../shared/startup/bspfatalextension.c \
     startup/bsppredriver.c ../../sparc/shared/bspgetworkarea.c \
     ../../sparc/shared/bsppretaskinghook.c ../../shared/bsppost.c \
Index: c/src/lib/libbsp/sparc/erc32/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sparc/erc32/include/bsp.h	(revision 38c0b1121f12e992fff6a85c18d8cabdbee0e213)
+++ c/src/lib/libbsp/sparc/erc32/include/bsp.h	(revision 7121cac0ccd234ac4d95abb2642ac0075c7fc1d0)
@@ -33,4 +33,6 @@
 #include <rtems/console.h>
 #include <rtems/irq-extension.h>
+
+#include <bsp/default-initial-extension.h>
 
 /*
Index: c/src/lib/libbsp/sparc/leon2/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/leon2/Makefile.am	(revision 38c0b1121f12e992fff6a85c18d8cabdbee0e213)
+++ c/src/lib/libbsp/sparc/leon2/Makefile.am	(revision 7121cac0ccd234ac4d95abb2642ac0075c7fc1d0)
@@ -47,4 +47,5 @@
 # startup
 libbsp_a_SOURCES += ../../shared/bspclean.c ../../shared/bsplibc.c \
+    ../shared/startup/bspfatalextension.c \
     ../../shared/bsppost.c startup/bsppredriver.c \
     startup/bspstart.c ../../sparc/shared/bsppretaskinghook.c \
Index: c/src/lib/libbsp/sparc/leon2/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sparc/leon2/include/bsp.h	(revision 38c0b1121f12e992fff6a85c18d8cabdbee0e213)
+++ c/src/lib/libbsp/sparc/leon2/include/bsp.h	(revision 7121cac0ccd234ac4d95abb2642ac0075c7fc1d0)
@@ -32,4 +32,6 @@
 #include <rtems/console.h>
 #include <rtems/irq-extension.h>
+
+#include <bsp/default-initial-extension.h>
 
 /* SPARC CPU variant: LEON2 */
Index: c/src/lib/libbsp/sparc/leon3/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/leon3/Makefile.am	(revision 38c0b1121f12e992fff6a85c18d8cabdbee0e213)
+++ c/src/lib/libbsp/sparc/leon3/Makefile.am	(revision 7121cac0ccd234ac4d95abb2642ac0075c7fc1d0)
@@ -31,4 +31,5 @@
 # startup
 libbsp_a_SOURCES += ../../shared/bspclean.c ../../shared/bsplibc.c \
+    ../shared/startup/bspfatalextension.c \
     ../../shared/bsppost.c ../../shared/bootcard.c startup/bspstart.c \
     ../../sparc/shared/bsppretaskinghook.c startup/bsppredriver.c \
Index: c/src/lib/libbsp/sparc/leon3/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sparc/leon3/include/bsp.h	(revision 38c0b1121f12e992fff6a85c18d8cabdbee0e213)
+++ c/src/lib/libbsp/sparc/leon3/include/bsp.h	(revision 7121cac0ccd234ac4d95abb2642ac0075c7fc1d0)
@@ -32,4 +32,6 @@
 #include <rtems/console.h>
 #include <rtems/irq-extension.h>
+
+#include <bsp/default-initial-extension.h>
 
 /* SPARC CPU variant: LEON3 */
Index: c/src/lib/libbsp/sparc/shared/startup/bspfatalextension.c
===================================================================
--- c/src/lib/libbsp/sparc/shared/startup/bspfatalextension.c	(revision 7121cac0ccd234ac4d95abb2642ac0075c7fc1d0)
+++ c/src/lib/libbsp/sparc/shared/startup/bspfatalextension.c	(revision 7121cac0ccd234ac4d95abb2642ac0075c7fc1d0)
@@ -0,0 +1,24 @@
+/*
+ * Copyright (c) 2012 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Obere Lagerstr. 30
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.com/license/LICENSE.
+ */
+
+#include <bsp.h>
+
+void bsp_fatal_extension(
+  Internal_errors_Source source,
+  bool is_internal,
+  Internal_errors_t error
+)
+{
+  BSP_fatal_return();
+}