Index: bsp-howto/index.rst
===================================================================
--- bsp-howto/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ bsp-howto/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -1,10 +1,10 @@
 .. comment SPDX-License-Identifier: CC-BY-SA-4.0
 
-=======================================
-BSP and Device Driver Development Guide
-=======================================
+==========================================================
+RTEMS BSP and Device Driver Development Guide (|version|).
+==========================================================
 
-BSP and Device Driver Development Guide
----------------------------------------
+RTEMS BSP and Device Driver Development Guide
+---------------------------------------------
 
  | COPYRIGHT (c) 1988 - 2015.
Index: c-user/conf.py
===================================================================
--- c-user/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ c-user/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -7,7 +7,7 @@
 release = '4.11.99'
 
-project = "RTEMS C User Manual"
+project = "RTEMS Classic API Guide"
 
 latex_documents = [
-	('index', 'c-user.tex', u'RTEMS C User Documentation', u'RTEMS Documentation Project', 'manual'),
+	('index', 'c-user.tex', u'RTEMS Classic API Guide', u'RTEMS Documentation Project', 'manual'),
 ]
Index: c-user/index.rst
===================================================================
--- c-user/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ c-user/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -1,10 +1,10 @@
 .. comment SPDX-License-Identifier: CC-BY-SA-4.0
 
-====================
-RTEMS C User's Guide
-====================
+====================================
+RTEMS Classic API Guide (|version|).
+====================================
 
-RTEMS C User's Guide
---------------------
+RTEMS Classic API Guide
+-----------------------
 
  | COPYRIGHT (c) 1988 - 2015.
Index: cpu-supplement/conf.py
===================================================================
--- cpu-supplement/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ cpu-supplement/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -7,7 +7,7 @@
 release = '4.11.99'
 
-project = "RTEMS CPU Supplement Documentation"
+project = "RTEMS CPU Architecture Supplement"
 
 latex_documents = [
-	('index', 'cpu-supplement.tex', u'RTEMS CPU Supplement Documentation', u'RTEMS Documentation Project', 'manual'),
+	('index', 'cpu-supplement.tex', u'RTEMS CPU Architecture Supplement', u'RTEMS Documentation Project', 'manual'),
 ]
Index: cpu-supplement/index.rst
===================================================================
--- cpu-supplement/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ cpu-supplement/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -1,7 +1,7 @@
 .. comment SPDX-License-Identifier: CC-BY-SA-4.0
 
-=================================
-RTEMS CPU Architecture Supplement
-=================================
+==============================================
+RTEMS CPU Architecture Supplement (|version|).
+==============================================
 
 RTEMS CPU Architecture Supplement
Index: develenv/conf.py
===================================================================
--- develenv/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ develenv/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -8,4 +8,4 @@
 
 latex_documents = [
-	('index', 'develenv.tex', u'RTEMS Development Environment Documentation', u'RTEMS Documentation Project', 'manual'),
+	('index', 'develenv.tex', u'RTEMS Development Environment Guide', u'RTEMS Documentation Project', 'manual'),
 ]
Index: develenv/index.rst
===================================================================
--- develenv/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ develenv/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -1,7 +1,7 @@
 .. comment SPDX-License-Identifier: CC-BY-SA-4.0
 
-===================================
-RTEMS Development Environment Guide
-===================================
+================================================
+RTEMS Development Environment Guide (|version|).
+================================================
 
 RTEMS Development Environment Guide
Index: eclipse/index.rst
===================================================================
--- eclipse/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ eclipse/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -6,7 +6,7 @@
 .. highlight:: c
 
-====================
-RTEMS Eclipse Manual
-====================
+=================================
+RTEMS Eclipse Manual (|version|).
+=================================
 
 RTEMS Eclipse Manual
Index: filesystem/index.rst
===================================================================
--- filesystem/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ filesystem/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -1,7 +1,7 @@
 .. comment SPDX-License-Identifier: CC-BY-SA-4.0
 
-=============================
-RTEMS Filesystem Design Guide
-=============================
+==========================================
+RTEMS Filesystem Design Guide (|version|).
+==========================================
 
 RTEMS Filesystem Design Guide
Index: networking/conf.py
===================================================================
--- networking/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ networking/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -10,4 +10,4 @@
 
 latex_documents = [
-	('index', 'networking.tex', u'RTEMS Networking User Documentation', u'RTEMS Documentation Project', 'manual'),
+	('index', 'networking.tex', u'RTEMS Networking User Manual', u'RTEMS Documentation Project', 'manual'),
 ]
Index: networking/index.rst
===================================================================
--- networking/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ networking/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -3,7 +3,7 @@
 .. highlight:: c
 
-===================================
-RTEMS |version| Network User Manual
-===================================
+======================================
+RTEMS Network User Manual (|version|).
+======================================
 
  | COPYRIGHT (c) 1988 - 2015.
Index: porting/conf.py
===================================================================
--- porting/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ porting/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -8,5 +8,5 @@
 
 latex_documents = [
-	('index', 'porting.tex', u'RTEMS Porting Documentation', u'RTEMS Documentation Project', 'manual'),
+	('index', 'porting.tex', u'RTEMS Porting Guide', u'RTEMS Documentation Project', 'manual'),
 ]
 
Index: porting/index.rst
===================================================================
--- porting/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ porting/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -1,7 +1,7 @@
 .. comment SPDX-License-Identifier: CC-BY-SA-4.0
 
-===================
-RTEMS Porting Guide
-===================
+================================
+RTEMS Porting Guide (|version|).
+================================
 COPYRIGHT (c) 1988 - 2015.
 
Index: posix-users/conf.py
===================================================================
--- posix-users/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ posix-users/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -7,7 +7,7 @@
 release = '4.11.99'
 
-project = "RTEMS POSIX User Manual"
+project = "RTEMS POSIX API Guide"
 
 latex_documents = [
-	('index', 'posix-users.tex', u'RTEMS POSIX API User\'s Guide', u'RTEMS Documentation Project', 'manual'),
+	('index', 'posix-users.tex', u'RTEMS POSIX API Guide', u'RTEMS Documentation Project', 'manual'),
 ]
Index: posix-users/index.rst
===================================================================
--- posix-users/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ posix-users/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -1,10 +1,10 @@
 .. comment SPDX-License-Identifier: CC-BY-SA-4.0
 
-============================
-RTEMS POSIX API User's Guide
-============================
+==================================
+RTEMS POSIX API Guide (|version|).
+==================================
 
-RTEMS POSIX API User's Guide
-----------------------------
+RTEMS POSIX API Guide
+---------------------
 
  | COPYRIGHT (c) 1988 - 2015.
Index: posix1003-1/conf.py
===================================================================
--- posix1003-1/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ posix1003-1/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -8,4 +8,4 @@
 
 latex_documents = [
-	('index', 'posix1003-1.tex', u'RTEMS POSIX 1003_1 Documentation', u'RTEMS Documentation Project', 'manual'),
+	('index', 'posix1003-1.tex', u'RTEMS POSIX 1003.1 Compliance Guide', u'RTEMS Documentation Project', 'manual'),
 ]
Index: posix1003-1/index.rst
===================================================================
--- posix1003-1/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ posix1003-1/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -1,7 +1,7 @@
 .. comment SPDX-License-Identifier: CC-BY-SA-4.0
 
-===================================
-RTEMS POSIX 1003.1 Compliance Guide
-===================================
+================================================
+RTEMS POSIX 1003.1 Compliance Guide (|version}).
+================================================
 
 COPYRIGHT (c) 1988 - 2015.
Index: rsb/conf.py
===================================================================
--- rsb/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ rsb/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -7,5 +7,5 @@
 release = '4.11.99'
 
-project = "RTEMS Source Builder Manual"
+project = "RTEMS Source Builder"
 
 latex_documents = [
Index: rsb/index.rst
===================================================================
--- rsb/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ rsb/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -9,7 +9,7 @@
 .. highlight:: shell
 
-==============================
-RTEMS |version| Source Builder
-==============================
+=================================
+RTEMS Source Builder (|version|).
+=================================
 
  | COPYRIGHT (c) 2012 - 2016.
Index: shell/conf.py
===================================================================
--- shell/conf.py	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ shell/conf.py	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -7,7 +7,7 @@
 release = '4.11.99'
 
-project = "RTEMS Shell Manual"
+project = "RTEMS Shell Guide"
 
 latex_documents = [
-	('index', 'shell.tex', u'RTEMS Shell Documentation', u'RTEMS Documentation Project', 'manual'),
+	('index', 'shell.tex', u'RTEMS Shell Guide', u'RTEMS Documentation Project', 'manual'),
 ]
Index: shell/index.rst
===================================================================
--- shell/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ shell/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -5,10 +5,10 @@
 .. COMMENT: All rights reserved.
 
-========================
-RTEMS Shell User's Guide
-========================
+==============================
+RTEMS Shell Guide (|version|).
+==============================
 
-RTEMS Shell User's Guide
-------------------------
+RTEMS Shell Guide
+-----------------
 
  | COPYRIGHT (c) 1988 - 2015.
Index: user/index.rst
===================================================================
--- user/index.rst	(revision d8beaabd02581bb42359400fe71659428aa76e8c)
+++ user/index.rst	(revision 7193f09294a087701e99d8dab1c58b357671aed6)
@@ -9,7 +9,7 @@
 .. highlight:: c
 
-============================
-RTEMS |version| User Manual.
-============================
+==============================
+RTEMS User Manual (|version|).
+==============================
 
 Table of Contents